// --------------------------------------------------------
// Tutorial.fsx
// --------------------------------------------------------
// FSX extension means that we're creating an F# Script
// (instead of a program that is supposed to be compiled)
//
// To evaluate an expression using 'F# Interactive' in VS,
// highlight the line and hit 'Alt + Enter'


// Expressions at a small scale
2*(2*2) - 5*2 + 3

// Using let bindings
let x = 2
2*(x*x) - 5*x + 3

// Calculating square roots
(-(-5.0) + sqrt ((pown -5.0 2) - 4.0*2.0*3.0)) / 2.0*2.0
(-(-5.0) - sqrt ((pown -5.0 2) - 4.0*2.0*3.0)) / 2.0*2.0

// ..better using discriminant:
let a, b, c = 2.0, -5.0, 3.0
let d = (pown b 2) - 4.0*a*c

(-b + sqrt d) / 2.0*a
(-b - sqrt d) / 2.0*a

// Value binding is an expression too!
10 + (let n = 2 * 3 in 100*n + n) + 20

// Printing to the console
printfn "Hello world!"

// Functions 'without' results also return!
let unitValue1 = ()
let unitValue2 = printfn "Hello world!"

// Sequencing expressions using ';'
let n1 = (printfn "calculating"; 10 + 4)

// Creating expressions that return unit using 'ignore'
let n2 = (ignore (10 + 2); 10 + 4)

// Booleans - short-circuiting behavior
true || (printfn "test"; true)    // printfn not called!
true && (printfn "test"; true)    // printfn called

// 'if' and 'match' expressions
if d = 0.0 then printfn "one solution"
elif d < 0.0 then printfn "no solutions"
else printfn "two solutions"

// 'if' is an expression too!
let n = (if d=0.0 then 1 elif d<0.0 then 0 else 2)

// when 'else' is missing, it returns unit value
if d < 0.0 then printfn "yay!"

// 'match' expression
match d with
| 0.0 -> printfn "one solution"
| discr when discr < 0.0 -> printfn "no solutions"
| _ -> printfn "two solutions"







